<?php

/*
+------------------------------------------------------------------------+
|        Sherman3D.com AJAX Chat for the E107 (www.e107.org) CMS system
|
|        Sherman Chin Lit Kong 2006
|        http://www.Sherman3D.com
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
+------------------------------------------------------------------------+
*/

header("Expires: Mon, 9 Oct 2006 01:00:00 GMT" ); 
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . "GMT" ); 
header("Cache-Control: no-cache, must-revalidate" ); 
header("Pragma: no-cache" );
header("Content-Type: text/plain; charset=utf-8");

// Get variables passed to us.
$lastRefreshTimeGet = $_GET['lastRefreshTime'];
$usernameGet = $_GET['username'];


// File to write chat lines to.
// Make sure the letters are in the same case as the file name in S3DChat_input for Unix systems.
$fileName="S3DChat.txt";
	
// Time before user appears offline.
$offlineTime = 60;

// Maximum lines in chat.
$maxLines = 20;

// Number of lines to delete when max lines is reached.					
$numLinesToDelete = 10;


// Create a line array out of chat file.
$lines = file($fileName);

$numLines = count($lines);
$writeToFile = "";
	
// If more than max lines.
if ($numLines>$maxLines)
{
	// Loop through all lines.
	for ($allCounter=0; $allCounter < $numLines; $allCounter++)
	{		
		// If more than lines to delete.
		if ($allCounter>$numLinesToDelete)
		{
			// Append lines for writing to file.
        	$writeToFile .= $lines[$allCounter];
		} // End if more than lines to delete.	
	} // End loop through all lines.
	
	// Delete chat file.
	unlink($fileName);
	// Recreate chat file.
    $fileOpen=@fopen($fileName,"w");
	// Write shortened lines to chat file.
    fwrite($fileOpen, $writeToFile);
    fclose($fileOpen);

} // End if more than max lines.
// Else if not more than max lines.
else
{
	// Get current time.
	$currentTime = time();
	
	$json = '{"messages": {';
	$json .= '"lastRefreshTime" : "'.$currentTime.'",';
	
    $json .= '"message":[';
    
    $bFlagAdded = false;
	
	// Loop through all lines.
	for ($counter=0; $counter < $numLines; $counter++)
	{	
		// Extract actual chat line.
		$chatLine = substr($lines[$counter],0,strpos($lines[$counter],"<>"));

		// Extract time.
		$time = substr( $lines[$counter], strpos($lines[$counter],"<>")+2, strpos($lines[$counter],">>") - strpos($lines[$counter],"<>")-2 );
		
		// Extract username
		$username = substr( $lines[$counter], strpos($lines[$counter],">>")+2, strpos($lines[$counter],"<<") - strpos($lines[$counter],">>")-2 );
		
		// Extract userID
		$userID = substr( $lines[$counter], strpos($lines[$counter],"<<")+2, strpos($lines[$counter],"><") - strpos($lines[$counter],"<<")-2 );
		
		// Extract userIP
		$userIP = trim( substr($lines[$counter], strpos($lines[$counter],"><")+2) );

		// if time of chat line is less than the current time and more than or equals to the time of the last update
		// and not posted by the current user (because we have local echo). Display all chat lines if page is refreshed ($lastRefreshTimeGet == 0).
		if (  
				(
					$time < $currentTime 
					&& 
					$time >= $lastRefreshTimeGet 
					&& 
					$username != $usernameGet
				)
				||
				$lastRefreshTimeGet == 0
			)
		{
				// Array element separator
				if ($bFlagAdded)
					$json .= ',';
					
				$bFlagAdded = true;
						
       			$json .= '{';
				$json .= '"username": "' 
							.$username. 
							'","userID": "' 
							.$userID.
							'","userIP": "' 
							.$userIP.  
							'","text": "' 
							.$chatLine. 
							'","time": "' 
							.$time. 
							'"}';

    			
			
		} // End if time of chat line is less than the current time and more than or equals to the time of the last update. 
	} // End loop through all lines.	
	
	// End message array.
	$json .= ']';
	
	// End messages and End root.
	$json .= '}}';
	echo $json;
				

} // End else if not more than max lines.	
?>